/*!
 * @file heat_particle.h
 * @brief A particle system to be used to generate particles that disturb the environment 
*/

#ifndef _HEAT_PARTICLES_H
#define _HEAT_PARTICLES_H

#include "world_entity.h"
#include "sprite_particles.h"

//! A particle system to be used to generate particles that disturb the environment 
class HeatParticles : public SpriteParticles
{
 ObjectListDeclaration(HeatParticles);

 public:
  HeatParticles(const TiXmlElement* root = NULL);
  virtual ~HeatParticles();

  virtual void loadParams(const TiXmlElement* root);
  void init();

  virtual void draw() const;
  virtual void tick(float time);

};

#endif /* _HEAT_PARTICLES_H */